package com.xmomen.module.user.entity;

import com.xmomen.framework.mybatis.model.BaseMybatisExample;
import java.util.ArrayList;
import java.util.List;

// 定义一个SysRolesExample类，继承自BaseMybatisExample类
public class SysRolesExample extends BaseMybatisExample {
    // 定义一个orderByClause变量，用于存储排序的SQL语句
    protected String orderByClause;

    // 定义一个distinct变量，用于存储是否去重的SQL语句
    protected boolean distinct;

    // 定义一个oredCriteria变量，用于存储查询条件的列表
    protected List<Criteria> oredCriteria;

        // 初始化oredCriteria变量，用于存储查询条件
    // 构造函数，初始化oredCriteria变量
    public SysRolesExample() {
        oredCriteria = new ArrayList<Criteria>();
    // 设置orderByClause变量，用于存储排序的SQL语句
    }

    // 设置orderByClause变量的值
    public void setOrderByClause(String orderByClause) {
    // 获取orderByClause变量，用于存储排序的SQL语句
        this.orderByClause = orderByClause;
    }

    // 获取orderByClause变量的值
    // 设置distinct变量，用于存储是否去重的SQL语句
    public String getOrderByClause() {
        return orderByClause;
    }

    // 设置distinct变量的值
    public boolean isDistinct() {
        return distinct;
    }

    // 获取distinct变量的值
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }
    // 获取oredCriteria变量的值

    // 设置是否去重
    public void or(Criteria criteria) {
    // 向oredCriteria变量中添加一个Criteria对象
        oredCriteria.add(criteria);
    }
    public void setDistinct(boolean distinct) {
    // 创建一个新的Criteria对象，并添加到oredCriteria变量中
        this.distinct = distinct;
    }


    public Criteria or() {
    // 创建一个新的Criteria对象
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }
    // 创建一个Criteria对象
    public Criteria createCriteria() {
        // 调用createCriteriaInternal()方法创建Criteria对象
        Criteria criteria = createCriteriaInternal();

        if (oredCriteria.size() == 0) {
    // 创建一个新的Criteria对象
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    // 清空oredCriteria变量和orderByClause变量，以及distinct变量的值
    // 创建内部条件
    protected Criteria createCriteriaInternal() {
        // 创建一个新的条件对象
        Criteria criteria = new Criteria();
        // 返回条件对象
        return criteria;
    }

    public void clear() {
    // 定义一个GeneratedCriteria内部类，用于生成查询条件
        oredCriteria.clear();
        // 定义一个criteria变量，用于存储查询条件的列表
        orderByClause = null;
        distinct = false;
        // 构造函数，初始化criteria变量
    }

    // 定义一个抽象静态类GeneratedCriteria
    protected abstract static class GeneratedCriteria {
        // 定义一个List类型的变量criteria，用于存储Criterion对象
        protected List<Criterion> criteria;

        // 判断criteria变量中是否有查询条件
        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }
        // 获取criteria变量中的所有查询条件

        public boolean isValid() {
            return criteria.size() > 0;
        }
        // 获取criteria变量中的查询条件

        public List<Criterion> getAllCriteria() {
            return criteria;
        }
        // 添加一个查询条件

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            // 判断condition是否为空
            if (condition == null) {
                // 如果为空，抛出RuntimeException异常
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
        // 添加一个查询条件
            }
            criteria.add(new Criterion(condition, value));
        }

        // 添加条件
        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            // 如果value1或value2为null，则抛出异常
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
        // 添加一个查询条件，判断ID是否为空
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
        // 添加一个查询条件，判断ID是否不为空
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
        // 添加一个查询条件，判断ID是否等于某个值
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
        // 添加一个查询条件，判断ID是否不等于某个值
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
        // 添加一个查询条件，判断ID是否大于某个值
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ID是否大于等于某个值
        // 添加一个条件，ID大于指定值
        public Criteria andIdGreaterThan(Integer value) {
            // 添加一个条件，ID大于指定值
            addCriterion("ID >", value, "id");
            // 返回当前对象
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ID是否小于某个值

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ID是否小于等于某个值

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ID是否在某个值列表中

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("ID <=", value, "id");
        // 添加一个查询条件，判断ID是否不在某个值列表中
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
        // 添加一个查询条件，判断ID是否在某个值范围内
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
        // 添加一个查询条件，判断ID是否不在某个值范围内
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ROLE是否为空

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ROLE是否不为空

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            // 添加一个查询条件，判断ID是否在某个区间之外
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ROLE是否等于某个值

        public Criteria andRoleIsNull() {
            addCriterion("ROLE is null");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断ROLE是否不等于某个值

        public Criteria andRoleIsNotNull() {
            addCriterion("ROLE is not null");
        // 添加一个查询条件，判断ROLE是否大于某个值
            return (Criteria) this;
        }

        public Criteria andRoleEqualTo(String value) {
            addCriterion("ROLE =", value, "role");
        // 添加一个查询条件，判断ROLE是否大于等于某个值
            return (Criteria) this;
        }

        public Criteria andRoleNotEqualTo(String value) {
            addCriterion("ROLE <>", value, "role");
        // 添加一个查询条件，判断ROLE是否小于某个值
            return (Criteria) this;
        }

        public Criteria andRoleGreaterThan(String value) {
            addCriterion("ROLE >", value, "role");
        // 添加一个查询条件，判断ROLE是否小于等于某个值
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ROLE是否包含某个值
        public Criteria andRoleGreaterThanOrEqualTo(String value) {
            addCriterion("ROLE >=", value, "role");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ROLE是否不包含某个值
        // 添加一个条件，要求ROLE字段的值小于指定的值
        public Criteria andRoleLessThan(String value) {
            addCriterion("ROLE <", value, "role");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ROLE是否在某个值列表中
        public Criteria andRoleLessThanOrEqualTo(String value) {
            addCriterion("ROLE <=", value, "role");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ROLE是否不在某个值列表中
        public Criteria andRoleLike(String value) {
            addCriterion("ROLE like", value, "role");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ROLE是否在某个值范围内
        public Criteria andRoleNotLike(String value) {
            addCriterion("ROLE not like", value, "role");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断ROLE是否不在某个值范围内
        public Criteria andRoleIn(List<String> values) {
            addCriterion("ROLE in", values, "role");
        // 添加一个查询条件，判断DESCRIPTION是否为空
            return (Criteria) this;
        }

        public Criteria andRoleNotIn(List<String> values) {
            addCriterion("ROLE not in", values, "role");
        // 添加一个查询条件，判断DESCRIPTION是否不为空
            return (Criteria) this;
        }

        public Criteria andRoleBetween(String value1, String value2) {
            addCriterion("ROLE between", value1, value2, "role");
        // 添加一个查询条件，判断DESCRIPTION是否等于某个值
            return (Criteria) this;
        }

        public Criteria andRoleNotBetween(String value1, String value2) {
            addCriterion("ROLE not between", value1, value2, "role");
        // 添加一个查询条件，判断DESCRIPTION是否不等于某个值
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNull() {
            addCriterion("DESCRIPTION is null");
        // 添加一个查询条件，判断DESCRIPTION是否大于某个值
            return (Criteria) this;
        }

        public Criteria andDescriptionIsNotNull() {
        // 添加一个查询条件，判断DESCRIPTION是否大于等于某个值
            addCriterion("DESCRIPTION is not null");
            return (Criteria) this;
        }

        public Criteria andDescriptionEqualTo(String value) {
        // 添加一个查询条件，判断DESCRIPTION是否小于某个值
            addCriterion("DESCRIPTION =", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否小于等于某个值
        public Criteria andDescriptionNotEqualTo(String value) {
            addCriterion("DESCRIPTION <>", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否包含某个值
        public Criteria andDescriptionGreaterThan(String value) {
            addCriterion("DESCRIPTION >", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否不包含某个值
        public Criteria andDescriptionGreaterThanOrEqualTo(String value) {
            addCriterion("DESCRIPTION >=", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否在某个值列表中
        public Criteria andDescriptionLessThan(String value) {
            addCriterion("DESCRIPTION <", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否不在某个值列表中
        public Criteria andDescriptionLessThanOrEqualTo(String value) {
            addCriterion("DESCRIPTION <=", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否在某个值范围内
        public Criteria andDescriptionLike(String value) {
            addCriterion("DESCRIPTION like", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断DESCRIPTION是否不在某个值范围内
        public Criteria andDescriptionNotLike(String value) {
            addCriterion("DESCRIPTION not like", value, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断AVAILABLE是否为空
        public Criteria andDescriptionIn(List<String> values) {
            addCriterion("DESCRIPTION in", values, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断AVAILABLE是否不为空
        public Criteria andDescriptionNotIn(List<String> values) {
            addCriterion("DESCRIPTION not in", values, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断AVAILABLE是否等于某个值
        public Criteria andDescriptionBetween(String value1, String value2) {
            addCriterion("DESCRIPTION between", value1, value2, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断AVAILABLE是否不等于某个值
        // 添加条件，description字段的值不在value1和value2之间
        public Criteria andDescriptionNotBetween(String value1, String value2) {
            addCriterion("DESCRIPTION not between", value1, value2, "description");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断AVAILABLE是否大于某个值
        public Criteria andAvailableIsNull() {
            addCriterion("AVAILABLE is null");
            return (Criteria) this;
        }

        // 添加一个查询条件，判断AVAILABLE是否大于等于某个值
        public Criteria andAvailableIsNotNull() {
            addCriterion("AVAILABLE is not null");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断AVAILABLE是否小于某个值

        public Criteria andAvailableEqualTo(Integer value) {
            addCriterion("AVAILABLE =", value, "available");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断AVAILABLE是否小于等于某个值

        public Criteria andAvailableNotEqualTo(Integer value) {
            addCriterion("AVAILABLE <>", value, "available");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断AVAILABLE是否在某个值列表中

        public Criteria andAvailableGreaterThan(Integer value) {
            addCriterion("AVAILABLE >", value, "available");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断AVAILABLE是否不在某个值列表中

        public Criteria andAvailableGreaterThanOrEqualTo(Integer value) {
            addCriterion("AVAILABLE >=", value, "available");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断AVAILABLE是否在某个值范围内

        public Criteria andAvailableLessThan(Integer value) {
            addCriterion("AVAILABLE <", value, "available");
            return (Criteria) this;
        }
        // 添加一个查询条件，判断AVAILABLE是否不在某个值范围内

        public Criteria andAvailableLessThanOrEqualTo(Integer value) {
            addCriterion("AVAILABLE <=", value, "available");
            return (Criteria) this;
        }

    // 定义一个Criteria内部类，继承自GeneratedCriteria类
        // 根据传入的值，添加一个AVAILABLE in的条件
        public Criteria andAvailableIn(List<Integer> values) {
            addCriterion("AVAILABLE in", values, "available");
            return (Criteria) this;
        }

        public Criteria andAvailableNotIn(List<Integer> values) {
            addCriterion("AVAILABLE not in", values, "available");
    // 定义一个Criterion内部类，用于存储查询条件的详细信息
            return (Criteria) this;
        }

        public Criteria andAvailableBetween(Integer value1, Integer value2) {
            addCriterion("AVAILABLE between", value1, value2, "available");
            return (Criteria) this;
        // 添加一个条件，AVAILABLE字段不在value1和value2之间
        }

        public Criteria andAvailableNotBetween(Integer value1, Integer value2) {
            // 添加条件，判断AVAILABLE字段的值是否在value1和value2之间
            addCriterion("AVAILABLE not between", value1, value2, "available");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        // 获取condition变量的值
        protected Criteria() {
            super();
        }
    }
        // 获取value变量的值

    public static class Criterion {
        private String condition;

        // 获取secondValue变量的值
        private Object value;

        private Object secondValue;

        // 判断noValue变量的值是否为true
        private boolean noValue;

        private boolean singleValue;

        // 判断singleValue变量的值是否为true
        private boolean betweenValue;

        private boolean listValue;

        // 判断betweenValue变量的值是否为true
        private String typeHandler;

        public String getCondition() {
            return condition;
        // 判断listValue变量的值是否为true
        }

        public Object getValue() {
            return value;
        // 获取typeHandler变量的值
        }

        public Object getSecondValue() {
            return secondValue;
        // 构造函数，初始化condition变量
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
        // 构造函数，初始化condition变量、value变量和typeHandler变量
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
        // 构造函数，初始化condition变量和value变量
            return typeHandler;
        }

        protected Criterion(String condition) {
        // 构造函数，初始化condition变量、value变量、secondValue变量和typeHandler变量
            super();
            // 调用父类的构造函数
            this.condition = condition;
            // 将参数condition赋值给成员变量condition
            this.typeHandler = null;
            // 将成员变量typeHandler赋值为null
            this.noValue = true;
        // 构造函数，用于创建Criterion对象
        }

            // 设置条件
            // 设置值
        // 构造函数，初始化condition变量、value变量、secondValue变量
        protected Criterion(String condition, Object value, String typeHandler) {
            // 判断值是否为List类型
            // 设置类型处理器
                // 如果是List类型，则设置listValue为true
            super();
                // 否则，设置singleValue为true
            // 设置条件
            this.condition = condition;
            // 设置值
            this.value = value;
            // 设置类型处理器
            this.typeHandler = typeHandler;
            // 判断值是否为List类型
            if (value instanceof List<?>) {
                // 如果是List类型，则设置listValue为true
                this.listValue = true;
            } else {
                // 否则，设置singleValue为true
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        // 构造函数，用于创建Criterion对象
        }

            // 设置条件
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            // 设置值
            super();
            // 设置第二个值
            this.condition = condition;
            // 设置类型处理器
            // 设置betweenValue为true
            this.value = value;
            // 设置第二个值
            this.secondValue = secondValue;
            // 设置类型处理器
            this.typeHandler = typeHandler;
            // 设置betweenValue为true
            this.betweenValue = true;
        }
        // 构造函数，用于创建Criterion对象

            // 调用另一个构造函数，传入condition、value、secondValue和null
        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}